import javax.servlet.http.*;
import javax.servlet.*;
import java.util.*;
import java.io.*;
import java.math.*;
import com.ibm.as400.access.*;
import com.ibm.etools.iseries.ui.RecordIOManager;
import javax.swing.table.DefaultTableModel;

public class AddtoBasket extends HttpServlet {

	private String[] hostInfo;
	private String success = "SUCCESS";
	private String notEnough = "NOT_ENOUGH";
	private String accessError = "ACCESS_ERROR";

	public class MyRecordIOManager extends RecordIOManager {
		public MyRecordIOManager(
			String hostInfo1,
			String hostInfo2,
			String hostInfo3,
			String file,
			String lib)
			throws Exception {
			super(hostInfo1, hostInfo2, hostInfo3, file, lib);
			setFileAccessType(RecordIOManager.FILEACCESS_KEYED);
			setCommitLockLevel(RecordIOManager.COMMITLOCKLEVEL_ALL);
			//journal has the same name as the database file
			setJournal(file);
			//journal is in the same library as the database file
			setJournalLibrary(lib);
		}
		private int findColumn(String size) {

			switch (size.substring(0, 1).toUpperCase().charAt(0)) {
				case 'S' :
					return 9;
				case 'M' :
					return 10;
				case 'L' :
					return 11;
				case 'X' :
					{
						if (size.substring(1, 2).toUpperCase().equals("L"))
							return 12;
						else
							if (size.substring(1, 2).toUpperCase().equals("X"))
								return 13;
					}
				default :
					return 0;
			}
		}
		public synchronized String updateDBFile(
			String id,
			String size,
			String quantity) {
			String status = null;
			Vector data = null, columns = null;
			String key[] = new String[1];
			BigDecimal newQuantity, totalNewQuantity;
			int sizeColumn,
				quantityAvailable,
				totalQuantityAvailable,
				quantityRequested,
				recNumber;
			int[] recordNumber = new int[1];
			key[0] = id;
			DefaultTableModel record = null, updatedRecord = null;
			sizeColumn = findColumn(size);
			quantityRequested = new Integer(quantity).intValue();

			//opening the file
			try {
				if (openFile()) {
					record = readRecord(key);
					quantityAvailable = ((BigDecimal) record.getValueAt(0, sizeColumn)).intValue();
					totalQuantityAvailable = ((BigDecimal) record.getValueAt(0, 8)).intValue();
					if (quantityRequested <= quantityAvailable) {
						newQuantity = new BigDecimal(quantityAvailable - quantityRequested);
						totalNewQuantity = new BigDecimal(totalQuantityAvailable - quantityRequested);
						record.setValueAt(newQuantity, 0, sizeColumn);
						record.setValueAt(totalNewQuantity, 0, 8);
						updateRecord(record);
						status = success;
					} else {
						status = notEnough;
					}
				} else
					status = accessError;
			} catch (Exception e) {
				e.printStackTrace();
				status = accessError;
			}

			//closing the file and adding 
			try {

				closeFile();
			} catch (Exception e) {
				//in case of error rollback
				try {
					rollback();
				} catch (Exception e1) {

				}
				status = accessError;
			}

			return status;
		}
	}
	public void init() {
		hostInfo = GetItems.getHostInfo();

	}

	public void doGet(HttpServletRequest req, HttpServletResponse res) {
		String id = null, size = null, quantity = null, element = null, status = null;
		HttpSession session = req.getSession(true);
		res.setContentType("text/plain");
		Enumeration enum = req.getParameterNames();
		Basket basket = (Basket) session.getAttribute("basket");
		MyRecordIOManager recIO = (MyRecordIOManager) session.getAttribute("recIO");
		if (basket == null) {
			basket = new Basket();
			session.setAttribute("basket", basket);
		}

		if (recIO == null) {
			try {
				recIO =
					new MyRecordIOManager(
						hostInfo[0],
						hostInfo[1],
						hostInfo[2],
						GetItems.getInventoryFile(),
						GetItems.getRetailLibrary());
			} catch (Exception e) {
				try {
					res.sendRedirect("errorPage.html");
					return;
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		}
		id = req.getParameter("id");
		size = req.getParameter(id + "S");
		quantity = req.getParameter(id + "Q");

		status = recIO.updateDBFile(id, size, quantity);
		session.setAttribute("recIO", recIO);

		if (status.equals("SUCCESS")) {
			basket.addItem(id, quantity, size);
			try {
				res.sendRedirect("ViewBasket.jsp");
				return;
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			if (status.equals("NOT_ENOUGH")) {
				try {
					res.sendRedirect("insufficient.html");
					return;
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else
				if (status.equals("ACCESS_ERROR")) {
					try {
						res.sendRedirect("errorPage.html");
						return;
					} catch (Exception e) {
						e.printStackTrace();
					}
				}

		}

	}
}