
/**
*Description - Use PCML to call iSeries ILE program
*/ 

// Imports
import java.util.*;
import java.io.*;
import java.math.*;
import java.text.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.ibm.connector.*;
import com.ibm.connector.as400.*;
import com.ibm.as400.access.*;
import ProgramRecord_DetailPage;

public class DetailPageServlet extends HttpServlet implements Serializable
{
  /*****************************************************************************
  * Process incoming requests for information form a GET
  */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException
  {
     performTask(request, response);
  }
  
  /*****************************************************************************
  * Process incoming requests for information form a POST
  */
  public void doPost(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException
  {
     performTask(request, response);
  }

  public void performTask(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException
  {

       String errorPage = "";
       String tracePrefix = "WDT400:";
       boolean bTraceToErrorPage = false;
       ProgramCallCommand aProgramCallCommand = null;
       HttpSession session = request.getSession(true);
       try {


       String sJobNumber = "";
       String projectName = "SV000501";
       System.out.println( tracePrefix + " Servlet starts");
       tracePrefix += session.getId() + ":";
       aProgramCallCommand = new ProgramCallCommand( session, request, response, this, errorPage);
       if (session.isNew() || session.getAttribute("connctionSpec") == null) {
          System.out.println( tracePrefix + " setting up for new session");
          AS400ConnectionSpec connSpec = (AS400ConnectionSpec)aProgramCallCommand.getConnectionSpec();
          connSpec.setProjectName(projectName);
          connSpec.setServer(getServletContext().getInitParameter("WDT_HOSTNAME"));
          connSpec.setLogonID(getServletContext().getInitParameter("WDT_USERID"));
          connSpec.setLogonPassword(getServletContext().getInitParameter("WDT_PASSWORD"));
          String llist = getServletContext().getInitParameter("WDT_RUNTIMELIB");
          if (llist != null && llist.length()>0) {
             StringTokenizer token = new StringTokenizer(llist);
             int i = 0;
             Vector lib = new Vector();
             while (token.hasMoreElements()) {
                lib.addElement(token.nextToken());
                i++;
             }
             if (lib.size()>0) {
                String[] libl = new String[lib.size()];
                for (int j=0; j<lib.size(); j++)
                   libl[j] = (String)lib.elementAt(j);
                connSpec.setAS400LibList(libl);
             }
          }
          String traceFlag = getServletContext().getInitParameter("WDT_FLGERRORDETAILS");
          if (traceFlag != null && traceFlag.equalsIgnoreCase("true"))
             session.setAttribute("Affinity_TraceToErrorPage", new Boolean(true));
          session.setAttribute("Affinity_SessionListener", new AffinityBindingListener());
       }

       if (session.getAttribute("Affinity_TraceToErrorPage") != null && ((Boolean)session.getAttribute("Affinity_TraceToErrorPage")).booleanValue())
          bTraceToErrorPage = true;
       AS400 as400 = aProgramCallCommand.getAS400Object();
       sJobNumber = com.ibm.webtools.as400.GenericDebugSupport.getJobNumber(as400);
       tracePrefix += sJobNumber + ";";
       aProgramCallCommand.setTraceToErrorPage(bTraceToErrorPage, tracePrefix);
       //Clear error
       session.removeAttribute("Affinity_ErrorField");
       session.removeAttribute("Affinity_ErrorMessageText");
       //Getting inputs from page
       String[] _inputs = null;
       if (request.getParameter("PRODNO") != null ) {
          String[] inputs = request.getParameterValues("PRODNO");
          session.setAttribute("Affinity_I_PRODNO", inputs);
       }
       if (request.getParameter("Submit") != null ) {
          String[] inputs = request.getParameterValues("Submit");
          session.setAttribute("Affinity_I_Submit", inputs);
       }

       //handle next/prev navigation
       String nextPage = request.getParameter("affinity_next");
       if(nextPage == null || nextPage.trim().length() == 0)
           nextPage = request.getParameter("affinity_previous");
       if(nextPage != null && nextPage.trim().length() > 0) {
           if(nextPage.charAt(0)!='/')
               nextPage = "/" + nextPage;
           getServletContext().getRequestDispatcher(nextPage).forward(request,response);
           return;
       }
       ((AS400InteractionSpec)aProgramCallCommand.getInteractionSpec()).setProgramName("DetailPage");
       ProgramRecord_DetailPage dataBean = new ProgramRecord_DetailPage();
       for (int i=0; i<1; i++)
          dataBean.setPRODNO(  new BigDecimal("0"));
       _inputs = null;
       if(session.getAttribute("Affinity_I_PRODNO") != null)
          _inputs = (String[])session.getAttribute("Affinity_I_PRODNO");
       if (_inputs == null) {
          _inputs = new String[1];
          _inputs[0] = "0";
       }
       if (_inputs != null) {
          for (int i=0; i<_inputs.length && i<1; i++) {
             if (_inputs[i].length() >0) {
                 _inputs[i] = stripNonNumeric( _inputs[i], 5, 0);
                System.out.println(tracePrefix + "Input parameter: PRODNO Value:" + _inputs[i]);
       	        dataBean.setPRODNO(  new BigDecimal(_inputs[i]));
             }
          }
       }
       
       //Execute Bean Methods
       aProgramCallCommand.setInput(dataBean);
       aProgramCallCommand.setOutput(dataBean);
       // if debug is on
       if ( session.getAttribute("_debugCallsDebugStart") != null && ((Boolean)session.getAttribute("_debugCallsDebugStart")).booleanValue()) {
          ServiceProgramCall svPgm = new ServiceProgramCall( as400);
          ProgramParameter[] parmList = new ProgramParameter[5];
          String sDebugIPAddr = (String)session.getAttribute("_debugIPAddr");
          AS400Text debugIPAddr = new AS400Text(sDebugIPAddr.length()+1, as400);
          parmList[0] = new ProgramParameter();
          parmList[0].setInputData( debugIPAddr.toBytes(sDebugIPAddr + "\0"));
          parmList[0].setParameterType( ProgramParameter.PASS_BY_REFERENCE);
          String sDebugPort = (String)session.getAttribute("_debugPort");
          AS400Text debugPort = new AS400Text( sDebugPort.length()+1, as400);
          parmList[1] = new ProgramParameter();
          parmList[1].setInputData( debugPort.toBytes(sDebugPort + "\0"));
          parmList[1].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          int len = sJobNumber.length();
          String debugJobNumber = "/" + sJobNumber.substring(len-7);
          AS400Text jobNumber = new AS400Text(debugJobNumber.length()+1, as400);
          parmList[2] = new ProgramParameter();
          parmList[2].setInputData( jobNumber.toBytes(debugJobNumber + "\0"));
          parmList[2].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          String sDebugListenerIPAddr = (String)session.getAttribute("_debugListenerIPAddr");
          AS400Text debugListenerIPAddr = new AS400Text(sDebugListenerIPAddr.length()+1, as400);
          parmList[3] = new ProgramParameter();
          parmList[3].setInputData(debugListenerIPAddr.toBytes(sDebugListenerIPAddr + "\0"));
          parmList[3].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          String sDebugListenerPort = (String)session.getAttribute("_debugListenerPort");
          AS400Text debugListenerPort = new AS400Text(sDebugListenerPort.length()+1, as400);
          parmList[4] = new ProgramParameter();
          parmList[4].setInputData( debugListenerPort.toBytes(sDebugListenerPort + "\0"));
          parmList[4].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          svPgm.setProgram("/QSYS.LIB/Q5BKICKS.SRVPGM", parmList);
          svPgm.setProcedureName("debug_start_affinity");
          svPgm.setReturnValueFormat(ServiceProgramCall.RETURN_INTEGER);
          System.out.println( tracePrefix + " Calling debug kicker");
          if ( svPgm.run() != true) {
             AS400Message[] messageList = svPgm.getMessageList();
             for (int msg = 0; msg < messageList.length; msg++)
                 System.out.println( messageList[msg].toString());
          }
          else {
             AS400Bin4 bin4 = new AS400Bin4();
             Integer RC = (Integer)bin4.toObject(svPgm.getReturnValue(),0);
             System.out.println("return code from kicker: " + RC.toString());
             session.setAttribute("_debugCallsDebugStart", new Boolean( false));
          }
       }
       // call the host program
       System.out.println(tracePrefix + " Calling host program");
       aProgramCallCommand.execute();
       System.out.println(tracePrefix + " Host program call completed");

       //Clean session variables
       Enumeration en = session.getAttributeNames();
       if(en != null)
           while(en.hasMoreElements()){
             String affinityName = (String)en.nextElement();
             if(affinityName != null && (affinityName.indexOf("Affinity_I_") == 0 || affinityName.indexOf("Affinity_O_") == 0))
                session.removeAttribute(affinityName);
       }

       //Place method results in the session

       String[] outputs = null;
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getPRODNO().toString();
            System.out.println(tracePrefix + "Output parameter: PRODNO Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_PRODNO", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getPRODNAME().toString();
            System.out.println(tracePrefix + "Output parameter: PRODNAME Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_PRODNAME", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getCOLOR().toString();
            System.out.println(tracePrefix + "Output parameter: COLOR Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_COLOR", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getRPRICE().toString();
            System.out.println(tracePrefix + "Output parameter: RPRICE Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_RPRICE", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getIMAGE().toString();
            System.out.println(tracePrefix + "Output parameter: IMAGE Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_IMAGE", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getSTYLE().toString();
            System.out.println(tracePrefix + "Output parameter: STYLE Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_STYLE", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getSQTY().toString();
            System.out.println(tracePrefix + "Output parameter: SQTY Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_SQTY", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getMQTY().toString();
            System.out.println(tracePrefix + "Output parameter: MQTY Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_MQTY", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getLQTY().toString();
            System.out.println(tracePrefix + "Output parameter: LQTY Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_LQTY", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getXLQTY().toString();
            System.out.println(tracePrefix + "Output parameter: XLQTY Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_XLQTY", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getXXLQTY().toString();
            System.out.println(tracePrefix + "Output parameter: XXLQTY Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_XXLQTY", outputs);
       nextPage ="/DetailPageResults.jsp";
       System.out.println(tracePrefix + "Posting output page:" + nextPage );
        
       //Forward the request to the next page
       RequestDispatcher dispatch = request.getRequestDispatcher(nextPage);
       dispatch.forward(request, response);
     }
     catch ( InvalidTransactionException ex) 
     { 
        String traceText; 
        AS400Message[] as400Message = aProgramCallCommand.getAS400Messages(); 
        traceText = tracePrefix + "InvalidTransactionException: " + ex.toString(); 
        System.out.println( traceText); 
        String[] traces = new String[1]; 
        traces[0] = traceText; 
        if ( bTraceToErrorPage) 
           session.setAttribute( "Affinity_ErrorTrace", traces); 
        if ( errorPage.length() >0) 
           getServletContext().getRequestDispatcher( errorPage).forward(request, response); 
        else 
          response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, traces[0] + 
                            "<BR><BR><PRE>\r\n" + printStackToString(ex) + "\r\n</PRE>"); 
     } 
     catch ( CommunicationException ex) 
     { 
       String[] traces = new String[1]; 
       String traceText = tracePrefix + "CommunicationException: " + ex.toString(); 
       System.out.println( traceText); 
       traces[0] = traceText; 
       if ( bTraceToErrorPage) 
         session.setAttribute( "Affinity_ErrorTrace", traces); 
       if ( errorPage.length() >0) 
         getServletContext().getRequestDispatcher( errorPage).forward(request, response); 
       else 
         response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, traces[0] + 
                            "<BR><BR><PRE>\r\n" + printStackToString(ex) + "\r\n</PRE>"); 
     } 
     catch (Throwable ex ) 
     { 
       ex.printStackTrace(); 
       String[] traces = new String[1]; 
       String traceText = tracePrefix + " : " + ex.toString(); 
       System.out.println( traceText); 
       traces[0] = traceText; 
       if ( bTraceToErrorPage) 
         session.setAttribute( "Affinity_ErrorTrace", traces); 
       if ( errorPage.length() >0) 
         getServletContext().getRequestDispatcher( errorPage).forward(request, response); 
       else 
         response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, traces[0] + 
                            "<BR><BR><PRE>\r\n" + printStackToString(ex) + "\r\n</PRE>"); 
     } 
   }


 
   /**
  * This will return an exception's stack trace as a String.
  */
  public static synchronized String printStackToString(Throwable aThrowable) 
  {
    try
    {
      ByteArrayOutputStream stream = new ByteArrayOutputStream();
      PrintWriter aPrintWriter = new PrintWriter(stream, true);
      aThrowable.printStackTrace(aPrintWriter);
      aPrintWriter.flush();
      aPrintWriter.close();
      stream.flush();
      stream.close();
      return stream.toString();
    }
    catch(Throwable ex) 
    { 
      return aThrowable.toString();
    }
  }



  private String stripNonNumeric(String input, int digits, int precision) {
     if (input.length() == 0)
        return new String("0");
     else {
        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
        char decSep = dfs.getDecimalSeparator();
        char minusSign = dfs.getMinusSign();
        String s = input;
        int idx = input.length();
        char c;
        while (--idx >= 0) {
           c = s.charAt(idx);
           if (!Character.isDigit(c) && c != decSep && c != minusSign)
              s = s.substring(0, idx) + s.substring(idx+1);
        }
        String intPart = "";
        String decPart = "";
        int dec = s.indexOf(decSep);
        if (dec > -1) {
           intPart = s.substring(0,dec);
           if (dec < s.length()-1)
              decPart = s.substring(dec+1);
           if (decPart.length() > 0) {
              if (decPart.length() > precision)
                 decPart = decPart.substring(0, precision);
           }
           return intPart + decSep + decPart;
        }
        else
          return s;
     }
  }

}

