import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.sql.*;
import org.w3c.dom.*;
import org.apache.xerces.parsers.*;
import org.xml.sax.*;
import com.ibm.as400.access.*;
/*
*/
public class GetItems extends HttpServlet {

	private File file = null;
	private Document doc = null;
	private Node root = null;
	private String as400 = null;
	private String userid = null;
	private String password = null;
	private String HOST_NAME = "WDT_HOSTNAME";
	private String USER_ID = "WDT_USERID";
	private String PASSWORD = "WDT_PASSWORD";
	private Connection as400conn = null;
	private DatabaseMetaData dmd = null;
	private int expirationInterval = 60;
	private static String[] hostInfo = null;
	private static String retailLibrary = "retailstor";
	private static String inventoryFile = "inventory";

	public static String[] getHostInfo() {
		return hostInfo;
	}

	public static String getRetailLibrary() {
		return retailLibrary;
	}

	public static String getInventoryFile() {
		return inventoryFile;
	}

	private void setParameterValue(Node node) {
		String value = null;
		String name = null;
		Node myNode = null;
		NodeList children = node.getChildNodes();
		NodeList myChildren = null;
		if (children != null) {
			for (int i = 0; i < children.getLength(); i++) {
				myNode = children.item(i);
				if (myNode.getNodeName() != null) {
					if (myNode.getNodeName().equals("param-name")) {
						NodeList tmp = myNode.getChildNodes();
						for (int m = 0; m < tmp.getLength(); m++) {
							Node textValue = tmp.item(m);
							if (textValue.getNodeType() == Node.TEXT_NODE) {
								name = textValue.getNodeValue();
							}
						}

					}
				}
				if (myNode.getNodeName().equals("param-value")) {
					NodeList tmp = myNode.getChildNodes();
					for (int m = 0; m < tmp.getLength(); m++) {
						Node textValue = tmp.item(m);
						if (textValue.getNodeType() == Node.TEXT_NODE) {
							value = textValue.getNodeValue();
						}
					}

				}

			}

			if (name != null)
				if (name.equals(HOST_NAME))
					as400 = value;
				else
					if (name.equals(USER_ID))
						userid = value;
					else
						if (name.equals(PASSWORD))
							password = value;

		}

	}

	public void init() {

		file = new File(getServletContext().getRealPath("/WEB-INF/web.xml"));
		hostInfo = new String[3];

		try {
			DOMParser parser = new DOMParser();
			parser.parse(new InputSource(new FileInputStream(file)));
			doc = parser.getDocument();
			root = doc.getDocumentElement();

		} catch (IOException ioe) {
			ioe.printStackTrace();
		} catch (SAXException saxe) {
			saxe.printStackTrace();
		}
		NodeList children1 = ((Element) root).getElementsByTagName("context-param");
		for (int i = 0; i < children1.getLength(); i++) {
			setParameterValue(children1.item(i));
		}

		hostInfo[0] = as400;
		hostInfo[1] = userid;
		hostInfo[2] = password;

		try {

			// Load the IBM Toolbox for Java JDBC driver.
			DriverManager.registerDriver(new com.ibm.as400.access.AS400JDBCDriver());

			as400conn =
				DriverManager.getConnection(
					"jdbc:as400://" + as400 + ";naming=sql;errors=full",
					userid,
					password);

			dmd = as400conn.getMetaData();
		} catch (Exception exc) {
			exc.printStackTrace();
		}

	}
	public void service(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, java.io.IOException {
		try {

			if (as400conn.isClosed()) {
				as400conn =
					DriverManager.getConnection(
						"jdbc:as400://" + as400 + ";naming=sql;errors=full",
						userid,
						password);

				dmd = as400conn.getMetaData();
			}
			Statement select =
				as400conn.createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_READ_ONLY);
			ResultSet rs =
				select.executeQuery(
					"SELECT PRODNO, PRODNAME, RPRICE, IMAGE FROM "
						+ retailLibrary
						+ dmd.getCatalogSeparator()
						+ inventoryFile);

			HttpSession session = request.getSession(true);
			session.setAttribute("resultset", rs);

			response.sendRedirect("/ViewItems.jsp");

		} catch (SQLException sqle) {
			System.out.println(sqle.getMessage());
			sqle.printStackTrace();
		}

	}

}