import javax.servlet.http.HttpServlet;
import javax.servlet.http.*;
import java.math.*;
import mappings.Order_OrderSupplyResultContentType;
import proxy.soap.OrderSupplyServicesProxy;

public class OrderSupplyServlet extends HttpServlet {

	public static final String NO_STOCK = "Insufficient stock to fulfill request";
	public static final String INVALID_NUMBER = "The requested stock number is not on file";
	public static final String UNKNOWN = "An unknown return code was received";
	public static final String FAIL = "An error occured ordering the item: ";
	public String me = this.getClass().getName() + ": ";
	public void doPost(
		javax.servlet.http.HttpServletRequest request,
		javax.servlet.http.HttpServletResponse response)
		throws javax.servlet.ServletException, java.io.IOException {
			performRequest(request, response);
	}

	public void doGet(
		javax.servlet.http.HttpServletRequest request,
		javax.servlet.http.HttpServletResponse response)
		throws javax.servlet.ServletException, java.io.IOException {
			performRequest(request, response);
	}

	public void performRequest(HttpServletRequest request, HttpServletResponse response) {
		
		HttpSession session = request.getSession(true);
		String nextPage = "orderok.jsp";
		
		// get the input parameteres
		BigDecimal quantity = new BigDecimal(request.getParameter("quantity"));
		BigDecimal item = new BigDecimal(request.getParameter("prodno"));
		String size = (String)request.getParameter("size");
		
		// create a proxy to use the service
		OrderSupplyServicesProxy proxy = new OrderSupplyServicesProxy();
		
		// invoke the proxy to order the item
		try {
			System.out.println(me + "Invoking order service");
			mappings.Order_OrderSupplyResultContentType t = proxy.OrderSupply(item, quantity, size);
			if(t.getReturnCode().equals("S")) {
				nextPage = "orderok.jsp";
			}
			else
				{
					nextPage = "orderfailed.jsp";
					if(t.getReturnCode().equals("I"))
						session.setAttribute("MSG", NO_STOCK);
					else if(t.getReturnCode().equals("U"))
						session.setAttribute("MSG", INVALID_NUMBER);
						else
							session.setAttribute("MSG", UNKNOWN);
			}
		}
		
		// Exception occurred invoking the service
		catch(Exception e) {
			nextPage = "orderfailed.jsp";
			session.setAttribute("MSG", FAIL + e.getMessage());
		}
		
		// return the output page
		System.out.println(me + "Returning output page");
		try {
			getServletContext().getRequestDispatcher(nextPage).forward(request, response);
		}
		catch(Exception e) {
			System.out.println(me + "Exception returning page: " + e);
		}	
	}
}
