import javax.servlet.http.HttpServlet;
import javax.servlet.http.*;
import java.io.*;
import java.math.*;
import proxy.soap.QryProdCostServicesProxy;
import mappings.*;
import com.ibm.etools.xsd.bean.runtime.AnyType;
import org.apache.soap.*;

public class QryProdCostServlet extends HttpServlet {

	public final static int OK = 0;
	public final static int NOSTOCK = 1;
	public final static String SOAP_ERROR = "Error occured retrieving cost from the wholesaler: " ;
	
	public void doPost(
		javax.servlet.http.HttpServletRequest request,
		javax.servlet.http.HttpServletResponse response)
		throws javax.servlet.ServletException, java.io.IOException {
			performRequest(request, response);
	}

	public void doGet(
		javax.servlet.http.HttpServletRequest request,
		javax.servlet.http.HttpServletResponse response)
		throws javax.servlet.ServletException, java.io.IOException {
			performRequest(request, response);
	}

	public void performRequest(HttpServletRequest request, HttpServletResponse response) {
		
		HttpSession session = request.getSession(true);
		BigDecimal prodno = new BigDecimal(request.getParameter("prodno"));
		CostBean cb = new CostBean();
		cb.setMessage(null);
		// create proxy to invoke web service
		QryProdCostServicesProxy proxy = new QryProdCostServicesProxy();
		try {
			System.out.println("Getting cost from proxy");
			// invoke the web service to get the cost of the item
			mappings.Wholesale_QryProdCostResultContentType t = proxy.QryProdCost(prodno);
			cb.setCost(t.getCost());
		}
		
		
		catch(Exception e) {
			System.out.println("Exception getting cost from proxy: " + e);
			cb.setMessage(SOAP_ERROR + e.getMessage());
		}
		
		
		cb.setProductNumber( prodno );
		
		request.setAttribute("cb", cb);
		try {
			getServletContext().getRequestDispatcher("ReturnedCost.jsp").forward(request, response);
		}
		catch(Exception e) {
			System.out.println("Exception: " + e);
		}	
	}
	
}
