
/**
*Description - Use PCML to call iSeries ILE program
*/ 

// Imports
import java.util.*;
import java.io.*;
import java.math.*;
import java.text.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.ibm.connector.*;
import com.ibm.connector.as400.*;
import com.ibm.as400.access.*;
import ProgramRecord_GetItem;

public class WitOrderServlet extends HttpServlet implements Serializable
{
  /*****************************************************************************
  * Process incoming requests for information form a GET
  */
  public void doGet(HttpServletRequest request, HttpServletResponse response)
  {
     performTask(request, response);
  }
  
  /*****************************************************************************
  * Process incoming requests for information form a POST
  */
  public void doPost(HttpServletRequest request, HttpServletResponse response)
  {
     performTask(request, response);
  }

  public void performTask(HttpServletRequest request, HttpServletResponse response)
  {
     try {

       String sJobNumber = "";
       String projectName = "SV000618";
       String errorPage = "";
       String tracePrefix = "WDT400:";
       boolean bTraceToErrorPage = false;
       ProgramCallCommand aProgramCallCommand = null;
       HttpSession session = request.getSession(true);
       System.out.println( tracePrefix + " Servlet starts");
       tracePrefix += session.getId() + ":";
       aProgramCallCommand = new ProgramCallCommand( session, request, response, this, errorPage);
       if (session.isNew() || session.getAttribute("connctionSpec") == null) {
          System.out.println( tracePrefix + " setting up for new session");
          AS400ConnectionSpec connSpec = (AS400ConnectionSpec)aProgramCallCommand.getConnectionSpec();
          connSpec.setProjectName(projectName);
          connSpec.setServer(getServletContext().getInitParameter("WDT_HOSTNAME"));
          connSpec.setLogonID(getServletContext().getInitParameter("WDT_USERID"));
          connSpec.setLogonPassword(getServletContext().getInitParameter("WDT_PASSWORD"));
          String llist = getServletContext().getInitParameter("WDT_RUNTIMELIB");
          if (llist != null && llist.length()>0) {
             StringTokenizer token = new StringTokenizer(llist);
             int i = 0;
             Vector lib = new Vector();
             while (token.hasMoreElements()) {
                lib.addElement(token.nextToken());
                i++;
             }
             if (lib.size()>0) {
                String[] libl = new String[lib.size()];
                for (int j=0; j<lib.size(); j++)
                   libl[j] = (String)lib.elementAt(j);
                connSpec.setAS400LibList(libl);
             }
          }
          String traceFlag = getServletContext().getInitParameter("FLGERRORDETAILS");
          if (traceFlag != null && traceFlag.equalsIgnoreCase("true"))
             session.setAttribute("Affinity_TraceToErrorPage", new Boolean(true));
          session.setAttribute("Affinity_SessionListener", new AffinityBindingListener());
       }

       if (session.getAttribute("Affinity_TraceToErrorPage") != null && ((Boolean)session.getAttribute("Affinity_TraceToErrorPage")).booleanValue())
          bTraceToErrorPage = true;
       AS400 as400 = aProgramCallCommand.getAS400Object();
       sJobNumber = com.ibm.webtools.as400.GenericDebugSupport.getJobNumber(as400);
       tracePrefix += sJobNumber + ";";
       aProgramCallCommand.setTraceToErrorPage(bTraceToErrorPage, tracePrefix);
       //Clear error
       session.removeAttribute("Affinity_ErrorField");
       session.removeAttribute("Affinity_ErrorMessageText");
       //Getting inputs from page
       String[] _inputs = null;
       if (request.getParameter("getPrice") != null ) {
          String[] inputs = request.getParameterValues("getPrice");
          session.setAttribute("Affinity_I_getPrice", inputs);
       }

       //handle next/prev navigation
       String nextPage = request.getParameter("affinity_next");
       if(nextPage == null || nextPage.trim().length() == 0)
           nextPage = request.getParameter("affinity_previous");
       if(nextPage != null && nextPage.trim().length() > 0) {
           if(nextPage.charAt(0)!='/')
               nextPage = "/" + nextPage;
           getServletContext().getRequestDispatcher(nextPage).forward(request,response);
           return;
       }
       ((AS400InteractionSpec)aProgramCallCommand.getInteractionSpec()).setProgramName("GetItem");
       ProgramRecord_GetItem dataBean = new ProgramRecord_GetItem();
       for (int i=0; i<1; i++)
          dataBean.setSubfile( " ");
       com.ibm.webtools.as400.SubFileControl.handleSubmit(request, response, this, errorPage);
       dataBean.setSubfile( "SFL1");
       
       //Execute Bean Methods
       aProgramCallCommand.setInput(dataBean);
       aProgramCallCommand.setOutput(dataBean);
       // if debug is on
       if ( session.getAttribute("_debugCallsDebugStart") != null && ((Boolean)session.getAttribute("_debugCallsDebugStart")).booleanValue()) {
          ServiceProgramCall svPgm = new ServiceProgramCall( as400);
          ProgramParameter[] parmList = new ProgramParameter[5];
          String sDebugIPAddr = (String)session.getAttribute("_debugIPAddr");
          AS400Text debugIPAddr = new AS400Text(sDebugIPAddr.length()+1, as400);
          parmList[0] = new ProgramParameter();
          parmList[0].setInputData( debugIPAddr.toBytes(sDebugIPAddr + "\0"));
          parmList[0].setParameterType( ProgramParameter.PASS_BY_REFERENCE);
          String sDebugPort = (String)session.getAttribute("_debugPort");
          AS400Text debugPort = new AS400Text( sDebugPort.length()+1, as400);
          parmList[1] = new ProgramParameter();
          parmList[1].setInputData( debugPort.toBytes(sDebugPort + "\0"));
          parmList[1].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          int len = sJobNumber.length();
          String debugJobNumber = "/" + sJobNumber.substring(len-7);
          AS400Text jobNumber = new AS400Text(debugJobNumber.length()+1, as400);
          parmList[2] = new ProgramParameter();
          parmList[2].setInputData( jobNumber.toBytes(debugJobNumber + "\0"));
          parmList[2].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          String sDebugListenerIPAddr = (String)session.getAttribute("_debugListenerIPAddr");
          AS400Text debugListenerIPAddr = new AS400Text(sDebugListenerIPAddr.length()+1, as400);
          parmList[3] = new ProgramParameter();
          parmList[3].setInputData(debugListenerIPAddr.toBytes(sDebugListenerIPAddr + "\0"));
          parmList[3].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          String sDebugListenerPort = (String)session.getAttribute("_debugListenerPort");
          AS400Text debugListenerPort = new AS400Text(sDebugListenerPort.length()+1, as400);
          parmList[4] = new ProgramParameter();
          parmList[4].setInputData( debugListenerPort.toBytes(sDebugListenerPort + "\0"));
          parmList[4].setParameterType(ProgramParameter.PASS_BY_REFERENCE);
          svPgm.setProgram("/QSYS.LIB/Q5BKICKS.SRVPGM", parmList);
          svPgm.setProcedureName("debug_start_affinity");
          svPgm.setReturnValueFormat(ServiceProgramCall.RETURN_INTEGER);
          System.out.println( tracePrefix + " Calling debug kicker");
          if ( svPgm.run() != true) {
             AS400Message[] messageList = svPgm.getMessageList();
             for (int msg = 0; msg < messageList.length; msg++)
                 System.out.println( messageList[msg].toString());
          }
          else {
             AS400Bin4 bin4 = new AS400Bin4();
             Integer RC = (Integer)bin4.toObject(svPgm.getReturnValue(),0);
             System.out.println("return code from kicker: " + RC.toString());
             session.setAttribute("_debugCallsDebugStart", new Boolean( false));
          }
       }
       // call the host program
       System.out.println(tracePrefix + " Calling host program");
       aProgramCallCommand.execute();
       System.out.println(tracePrefix + " Host program call completed");

       //Clean session variables
       Enumeration en = session.getAttributeNames();
       if(en != null)
           while(en.hasMoreElements()){
             String affinityName = (String)en.nextElement();
             if(affinityName != null && (affinityName.indexOf("Affinity_I_") == 0 || affinityName.indexOf("Affinity_O_") == 0))
                session.removeAttribute(affinityName);
       }

       //Setup flow control
       String sFlowCtrl;
       Hashtable htFlowControlTable = new Hashtable();
       htFlowControlTable.put("OK", "/GetCost.jsp");
       htFlowControlTable.put("NOTOK", "/nosel.jsp");

       //Place method results in the session

       String[] outputs = null;
       sFlowCtrl = dataBean.getFlow().toString();
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getInfo().getProdno().toString();
            System.out.println(tracePrefix + "Output parameter: info.prodno Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_info.prodno", outputs);
       session.setAttribute("prodno", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getInfo().getDesc().toString();
            System.out.println(tracePrefix + "Output parameter: info.desc Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_info.desc", outputs);
       session.setAttribute("desc", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getInfo().getCost().toString();
            System.out.println(tracePrefix + "Output parameter: info.cost Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_info.cost", outputs);
       session.setAttribute("cost", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getInfo().getRetail().toString();
            System.out.println(tracePrefix + "Output parameter: info.retail Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_info.retail", outputs);
       session.setAttribute("retail", outputs);
       outputs = new String[1];
          for (int i=0; i<1; i++) {
             outputs[i] = dataBean.getInfo().getImage().toString();
            System.out.println(tracePrefix + "Output parameter: info.image Value:" + outputs[i]);
          }
       session.setAttribute("Affinity_O_info.image", outputs);
       session.setAttribute("image", outputs);
       nextPage ="/GetCost.jsp";
       if(htFlowControlTable.containsKey(sFlowCtrl))
          nextPage = (String)htFlowControlTable.get(sFlowCtrl);
       else if(sFlowCtrl.length() > 1 && sFlowCtrl.charAt(0) == '/')
          nextPage = sFlowCtrl;
       System.out.println(tracePrefix + "Posting output page:" + nextPage );
        
       //Forward the request to the next page
       RequestDispatcher dispatch = request.getRequestDispatcher(nextPage);
       dispatch.forward(request, response);
    }
    catch (Throwable theException)
    {
         handleError(request, response, theException);
    }
  }


  public void handleError(HttpServletRequest request, 
                           HttpServletResponse response, 
                           Throwable e)
  {
     try
     {
        String message = e.getLocalizedMessage();
      	String stackTrace = printStackToString(e);
      	response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, message + 
      	                                 "<BR><BR><PRE>\n" + stackTrace + "</PRE>");
     }
     catch(Throwable ex)
     {
        ex.printStackTrace();
     } 
  }

    
   /**
   * This will return an exception's stack trace as a String.
   */
   public static synchronized String printStackToString(Throwable aThrowable) 
   {
      try
      {
         ByteArrayOutputStream stream = new ByteArrayOutputStream();
         PrintWriter aPrintWriter = new PrintWriter(stream, true);
         aThrowable.printStackTrace(aPrintWriter);
         aPrintWriter.flush();
         aPrintWriter.close();
         stream.flush();
         stream.close();
         return stream.toString();
      }
      catch(Throwable ex) 
      { 
         return aThrowable.toString();
      }
  }

  

}

